using System;
using System.Collections.Generic;
using System.Text;

namespace ITCrossing
{
	public class MetaPostException : Exception
	{
		private string _resourceKey;
		private bool _useGlobal;
		public MetaPostException(string resourceKey, string defaultMessage)
			: base(defaultMessage)
		{
			_resourceKey = resourceKey;
		}

		public MetaPostException(string resourceKey, string defaultMessage, bool useGlobal) : base(defaultMessage)
		{
			_resourceKey = resourceKey;
			_useGlobal = useGlobal;
		}

		public string ResourceKey
		{
			get { return _resourceKey; }
			set { _resourceKey = value; }
		}

		public bool UseGlobal
		{
			get { return _useGlobal; }
			set { _useGlobal = value; }
		}
	}
}
