#region Disclaimer/Info
// Original source from SubText - Removed most of the code since we decided to modify the way
// pings and trackbacks were being processed.
///////////////////////////////////////////////////////////////////////////////////////////////////
// Subtext WebLog
// 
// Subtext is an open source weblog system that is a fork of the .TEXT
// weblog system.
//
// For updated news and information please visit http://subtextproject.com/
// Subtext is hosted at SourceForge at http://sourceforge.net/projects/subtext
// The development mailing list is at subtext-devs@lists.sourceforge.net 
//
// This project is licensed under the BSD license.  See the License.txt file for more information.
///////////////////////////////////////////////////////////////////////////////////////////////////
#endregion

#region Notes
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // The code in this file is freely distributable.
 // 
 // ASPNetWeblog isnot responsible for, shall have no liability for 
 // and disclaims all warranties whatsoever, expressed or implied, related to this code,
 // including without limitation any warranties related to performance, security, stability,
 // or non-infringement of Title of the control.
 // 
 // If you have any questions, comments or concerns, please contact
 // Scott Watermasysk, Scott@TripleASP.Net.
 // 
 // For more information on this control, updates, and other tools to integrate blogging 
 // into your existing applications, please visit, http://aspnetweblog.com
 // 
 // Originally based off of code by Simon Fell http://www.pocketsoap.com/weblog/ 
 // 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
#endregion
using System;
using System.Text.RegularExpressions;
using CookComputing.XmlRpc;

namespace ITCrossing.Tracking
{
	/// <summary>
	/// Summary description for WeblogsNotificationProxy.
	/// </summary>
	/// 
	public class PingBackNotificatinProxy : XmlRpcClientProtocol
	{

		public bool Ping(Uri sourceURI, Uri targetURI, Uri pingbackServerUri)
		{
			try
			{
				Url = pingbackServerUri.ToString();
				Notify(sourceURI.ToString(), targetURI.ToString());
				return true;
			}
			catch // You know, some day it would be great to log this, but not today. 
			{
				return false;
			}
		}

		[XmlRpcMethod("pingback.ping")]
		public void Notify(string sourceURI, string targetURI)
		{
			Invoke("Notify", new object[] { sourceURI, targetURI });
		}

	}
}

