#region Disclaimer/Info
///////////////////////////////////////////////////////////////////////////////////////////////////
// Subtext WebLog
// 
// Subtext is an open source weblog system that is a fork of the .TEXT
// weblog system.
//
// For updated news and information please visit http://subtextproject.com/
// Subtext is hosted at SourceForge at http://sourceforge.net/projects/subtext
// The development mailing list is at subtext-devs@lists.sourceforge.net 
//
// This project is licensed under the BSD license.  See the License.txt file for more information.
///////////////////////////////////////////////////////////////////////////////////////////////////
#endregion

#region Notes
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // The code in this file is freely distributable.
 // 
 // ASPNetWeblog isnot responsible for, shall have no liability for 
 // and disclaims all warranties whatsoever, expressed or implied, related to this code,
 // including without limitation any warranties related to performance, security, stability,
 // or non-infringement of Title of the control.
 // 
 // If you have any questions, comments or concerns, please contact
 // Scott Watermasysk, Scott@TripleASP.Net.
 // 
 // For more information on this control, updates, and other tools to integrate blogging 
 // into your existing applications, please visit, http://aspnetweblog.com
 // 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
#endregion
using System;
using System.Configuration;
using System.IO;
using System.Net;
using System.Text.RegularExpressions;
using System.Web;


namespace ITCrossing.Tracking
{
	/// <summary>
	/// Summary description for TrackBackNotificationProxy.
	/// </summary>
	public class TrackBackNotificationProxy
	{	
		/// <summary>
		/// Initializes a new instance of the <see cref="TrackBackNotificationProxy"/> class.
		/// </summary>
		public TrackBackNotificationProxy()
		{
		}

		public bool TrackBackPing(Uri url, string title, Uri link, string blogname, string description)
		{
			try
			{
				string parameters = "Title=" + HttpUtility.HtmlEncode(title) + "&url=" +
				                    HttpUtility.HtmlEncode(link.ToString()) + "&blog_name=" +
				                    HttpUtility.HtmlEncode(blogname) + "&excerpt=" +
				                    HttpUtility.HtmlEncode(description);
				return SendPing(url, parameters);
			}
			catch // You know, some day it would be great to log this, but not today. 
			{
				return false;
			}
		}

		private bool SendPing(Uri trackBackItem, string parameters)
		{
			try
			{
				HttpWebRequest request = HttpHelper.CreateRequest(trackBackItem);
				request.Method = "POST";
				request.ContentLength = parameters.Length;
				request.ContentType = "application/x-www-form-urlencoded";
				request.KeepAlive = false;
				HttpHelper.SetProxy(request);

				using (StreamWriter myWriter = new StreamWriter(request.GetRequestStream()))
				{
					myWriter.Write(parameters);
				}

				HttpWebResponse response = (HttpWebResponse) request.GetResponse();

				bool success = (response.StatusCode == HttpStatusCode.OK);

				return success;

			}
			catch
			{
				return false;
			}
		}
	}
}

